#include <iostream>
#include <nlohmann/json.hpp>

#include <drogon/HttpClient.h>
#include "version.hpp"
#include "assert.hpp"

void crashy() {
    ASSERT(false, "SUCCESS!");
}

int main() {
    std::cout << "ipdemo version: " << ipdemo::VERSION << std::endl;
    std::cout << std::endl;
    std::cout << "Retrieving IP address..." << std::endl;

    auto loop = trantor::EventLoop::getEventLoopOfCurrentThread();
    auto client = drogon::HttpClient::newHttpClient("http://ipinfo.io", loop);
    auto req = drogon::HttpRequest::newHttpRequest();
    req->setMethod(drogon::Get);
    req->setPath("/ip");
    std::string ip_body;
    int status = 0;
    bool done = false;
    client->sendRequest(req, [&](drogon::ReqResult result, const drogon::HttpResponsePtr &resp) {
        if (result == drogon::ReqResult::Ok && resp) {
            ip_body = resp->body();
            status = resp->statusCode();
        } else {
            status = 0;
        }
        done = true;
    });
    while (!done) loop->loopOnce();

    ASSERT(status == 200, "Failed to get IP");

    nlohmann::json j;
    j["ip"] = ip_body;
    j["status"] = status;

    std::cout << j.dump(4) << std::endl;

    std::cout << "Done" << std::endl;

    crashy();

    return 0;
}
